//+------------------------------------------------------------------+
//|                                                     Fractals.mq4 |
//|                                 Copyright  31.03.2015, Medvedev |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  31.03.2015, Medvedev"
#property link      "http://www.mql4.com"
#property version   "1.00"
#property strict
bool fractal_buy, fractal_sell; 
extern int stop     = 15;
extern int take     = 33; 
extern double lot   = 0.01;
extern int slippage = 3;
extern int magic    = 1111;
//============================
double Tick, Spread, StopLevel, MinLot, MaxLot, LotStep; 
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
  Tick      = MarketInfo(Symbol(), MODE_TICKSIZE); //      
  Spread    = NormalizeDouble((MarketInfo(Symbol(), MODE_SPREAD)*Point),Digits); //  
  StopLevel = NormalizeDouble((MarketInfo(Symbol(), MODE_STOPLEVEL)*Point),Digits); //   
  MinLot    = MarketInfo(Symbol(), MODE_MINLOT); //    
  MaxLot    = MarketInfo(Symbol(), MODE_MAXLOT); //    
  LotStep   = MarketInfo(Symbol(), MODE_LOTSTEP);//          
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
      
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
  double fractal_up = iFractals(NULL,0,MODE_UPPER,3); 
  double fractal_dn = iFractals(NULL,0,MODE_LOWER,3);
  double Price;
  
  double stoploss;
  double takeprofit;
  string comment = "";
  color arrow_color = clrRed;
  
  if (lot < MinLot) lot = MinLot;
  if (lot > MaxLot) lot = MaxLot;
   
  if (fractal_up != 0 && !fractal_sell)
   {
   Price =NormalizeDouble(Bid,Digits);
   takeprofit = NormalizeDouble((Bid - take*Point),Digits);
   if ((Ask-takeprofit) <= StopLevel) 
      {
      takeprofit = NormalizeDouble((Ask-StopLevel-Tick),Digits);
      }
   stoploss = NormalizeDouble((Ask + stop*Point),Digits);
   if ((stoploss-Ask) <= StopLevel)
      {
      stoploss = NormalizeDouble((Ask+StopLevel+Tick),Digits);
      }
   comment = "   SELL";
   if (OrderSend(Symbol(), OP_SELL, lot, Bid, slippage, stoploss, takeprofit, comment, magic, 0, arrow_color))
      {
      fractal_sell = true;
      fractal_buy = false;
      }
   else
      {
      Print ("   SELL: ",GetLastError());
      }
   }
  
  if (fractal_dn != 0 && !fractal_buy)
   {
   Price = NormalizeDouble(Ask,Digits);
   takeprofit = NormalizeDouble((Bid + take*Point),Digits);
   if ((takeprofit-Bid) <= StopLevel)
      {
      takeprofit =  NormalizeDouble((Bid + StopLevel + Tick),Digits); 
      }
   stoploss = NormalizeDouble((Ask - stop*Point),Digits);
   if ((Bid-stoploss) <= StopLevel)
      {
      stoploss = NormalizeDouble((Bid - StopLevel - Tick),Digits); 
      }
   comment = "   BUY";
   arrow_color = clrBlue;
   if (OrderSend(Symbol(), OP_BUY, lot, Price, slippage, stoploss, takeprofit, comment, magic, 0, arrow_color))
      {
      fractal_buy = true;
      fractal_sell = false;
      }
   else
      {
      Print ("   BUY: ",GetLastError());
      }
   }
   
  }
